Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.ifs.server
Class S_Relationship

    java.lang.Object
      oracle.ifs.server.S_LibraryObject
          oracle.ifs.server.S_TieLibraryObject
              oracle.ifs.server.S_SystemObject
                  oracle.ifs.server.S_TieSystemObject
                      oracle.ifs.server.S_Relationship

All Implemented Interfaces:
  IfsEventHandler, LibraryObjectInterface, SystemObjectInterface, Traceable

Direct Known Subclasses:
  S_TieRelationship

    public class S_Relationship

extends S_TieSystemObject

The S_Relationship class is the server side implementation of the iFS RELATIONSHIP class

(Published)

Field Summary
`static java.lang.String` | `CLASS_NAME`

Fields inherited from class oracle.ifs.server.S_LibraryObject
`CASCADE_OP_COPY_PUBLICOBJECT_TO_CATEGORY, CASCADE_OP_COPY_PUBLICOBJECT_TO_RIGHT_RELATIONSHIP, CASCADE_OP_DELETE_FAMILY_TO_VERSIONSERIES, CASCADE_OP_DELETE_PUBLICOBJECT_TO_LEFT_RELATIONSHIP, CASCADE_OP_DELETE_PUBLICOBJECT_TO_RIGHT_RELATIONSHIP, CASCADE_OP_DELETE_PUBLICOBJECT_TO_VERSIONDESCRIPTION, CASCADE_OP_DELETE_RELATIONSHIP_TO_LEFT_PUBLICOBJECT, CASCADE_OP_DELETE_RELATIONSHIP_TO_RIGHT_PUBLICOBJECT, CASCADE_OP_DELETE_VERSIONDESCRIPTION_TO_PUBLICOBJECT, CASCADE_OP_DELETE_VERSIONDESCRIPTION_TO_VERSIONSERIES, CASCADE_OP_DELETE_VERSIONSERIES_TO_FAMILY, CASCADE_OP_DELETE_VERSIONSERIES_TO_VERSIONDESCRIPTION, CASCADE_OP_FREE_CATEGORY_TO_PUBLICOBJECT, CASCADE_OP_FREE_CATEGORY_TO_SCHEMAOBJECT, CASCADE_OP_FREE_CATEGORY_TO_SYSTEMOBJECT, CASCADE_OP_FREE_FAMILY_TO_VERSIONSERIES, CASCADE_OP_FREE_PUBLICOBJECT_TO_CATEGORY, CASCADE_OP_FREE_PUBLICOBJECT_TO_LEFT_RELATIONSHIP, CASCADE_OP_FREE_PUBLICOBJECT_TO_RIGHT_RELATIONSHIP, CASCADE_OP_FREE_PUBLICOBJECT_TO_VERSIONDESCRIPTION, CASCADE_OP_FREE_RELATIONSHIP_TO_LEFT_PUBLICOBJECT, CASCADE_OP_FREE_RELATIONSHIP_TO_RIGHT_PUBLICOBJECT, CASCADE_OP_FREE_SCHEMAOBJECT_TO_CATEGORY, CASCADE_OP_FREE_SYSTEMOBJECT_TO_CATEGORY, CASCADE_OP_FREE_VERSIONDESCRIPTION_TO_PUBLICOBJECT, CASCADE_OP_FREE_VERSIONDESCRIPTION_TO_VERSIONSERIES, CASCADE_OP_FREE_VERSIONSERIES_TO_FAMILY, CASCADE_OP_FREE_VERSIONSERIES_TO_VERSIONDESCRIPTION, CASCADE_OP_UNDEFINED, CASCADE_OP_UNDELETE_FAMILY_TO_VERSIONSERIES, CASCADE_OP_UNDELETE_PUBLICOBJECT_TO_LEFT_RELATIONSHIP, CASCADE_OP_UNDELETE_PUBLICOBJECT_TO_RIGHT_RELATIONSHIP, CASCADE_OP_UNDELETE_PUBLICOBJECT_TO_VERSIONDESCRIPTION, CASCADE_OP_UNDELETE_RELATIONSHIP_TO_LEFT_PUBLICOBJECT, CASCADE_OP_UNDELETE_RELATIONSHIP_TO_RIGHT_PUBLICOBJECT, CASCADE_OP_UNDELETE_VERSIONDESCRIPTION_TO_PUBLICOBJECT, CASCADE_OP_UNDELETE_VERSIONDESCRIPTION_TO_VERSIONSERIES, CASCADE_OP_UNDELETE_VERSIONSERIES_TO_FAMILY, CASCADE_OP_UNDELETE_VERSIONSERIES_TO_VERSIONDESCRIPTION, CASCADE_OP_UPDATE_CATEGORY_TO_PUBLICOBJECT, CASCADE_OP_UPDATE_CATEGORY_TO_SCHEMAOBJECT, CASCADE_OP_UPDATE_CATEGORY_TO_SYSTEMOBJECT, CASCADE_OP_UPDATE_PUBLICOBJECT_TO_CATEGORY, CASCADE_OP_UPDATE_SCHEMAOBJECT_TO_CATEGORY, CASCADE_OP_UPDATE_SYSTEMOBJECT_TO_CATEGORY, DEFAULT_RENDERER, m_ClassId, m_Id, m_Session`

Constructor Summary
`protected` | `S_Relationship(S_LibrarySession session, java.lang.Long classId)` Construct a S_Relationship object.
`protected` | `S_Relationship(S_LibrarySession session, S_LibraryObjectData data)` Construct a S_Relationship object.

Method Summary
`protected void` | `associatedPostFree(OperationState opState, S_LibraryObjectDefinition def)` an extensibility point for post free actions on associated objects.
`protected void` | `associatedPostInsert(OperationState opState, S_LibraryObjectDefinition def)` an extensibility point for post insert actions on associated objects.
`protected void` | `associatedPreInsert(OperationState opState, S_LibraryObjectDefinition def)` an extensibility point for pre insert actions on associated objects.
`protected void` | `cascadeDeleteToLeftObject(OperationState opState, S_LibraryObject source)` cascade to our left object, indicationg that we have Deleted.
`protected void` | `cascadeDeleteToRightObject(OperationState opState, S_LibraryObject source)` cascade to our right object, indicationg that we have Deleted.
`protected void` | `cascadeFree(OperationState opState, S_LibraryObjectDefinition def)` cascade operations to be performed before freeing an object.
`protected void` | `cascadeFreeToLeftObject(OperationState opState, S_LibraryObject source)` cascade to our left object, indicationg that we have freed.
`protected void` | `cascadeFreeToRightObject(OperationState opState, S_LibraryObject source)` cascade to our right object, indicationg that we have freed.
`protected void` | `cascadeUndeleteToLeftObject(OperationState opState, S_LibraryObject source)` cascade to our left object, indicationg that we have Undeleted.
`protected void` | `cascadeUndeleteToRightObject(OperationState opState, S_LibraryObject source)` cascade to our right object, indicationg that we have Undeleted.
`protected void` | `deriveDefinition(S_LibraryObjectDefinition def)` Add to the S_LibraryObjectDefinition for this class.
`protected void` | `extendedPostAddRelationship(OperationState opState, S_PublicObject rightpo, S_LibraryObjectDefinition def)` an extensibility point after a relationship is created.
`protected void` | `extendedPostRemoveRelationship(OperationState opState, S_PublicObject rightpo, S_LibraryObjectDefinition def)` an extensibility point after a relationship is removed.
`protected void` | `extendedPreAddRelationship(OperationState opState, S_PublicObject rightpo, S_LibraryObjectDefinition def)` an extensibility point before a relationship is created.
`protected void` | `extendedPreFree(OperationState opState, S_LibraryObjectDefinition def)` Processing appropriate for freeing this object Save the left object away for post free processing
`protected void` | `extendedPreInsert(OperationState opState, S_LibraryObjectDefinition sdef)` Update any system attributes appropriate for creating this object
`protected void` | `extendedPreRemoveRelationship(OperationState opState, S_PublicObject rightpo, S_LibraryObjectDefinition def)` an extensibility point before a relationship is removed.
`S_PublicObject` | `getLeftObject()` gets the S_PublicObject that is left of this relationship.
`S_PublicObject` | `getRightObject()` gets the S_PublicObject that is right of this relationship.
`protected void` | `handleCascade(OperationState opState, S_LibraryObject source, int cascadeType, S_LibraryObjectDefinition sdef, java.lang.Object customArg)` handle a cascaded operation initiated by (usually) another object.
`protected static S_Relationship[]` | `vectorToSRelationshipArray(S_LibrarySession sess, java.util.Vector vector)`

Methods inherited from class oracle.ifs.server.S_SystemObject
`addCategory, createCategories, extendedPostInsert, extendedPostUpdate, extendedPreUpdate, getCategories, getCategories, getCategories, removeCategories, updateCategories, verifyCanCreate, verifyCanFree, verifyCanUpdate`

Methods inherited from class oracle.ifs.server.S_LibraryObject
`applyValueDefault, cascadeCopy, cascadeUpdate, checkRequiredForInsert, checkSettable, clearArrayTypeAttributeValues, clonePublicObjectAttribute, constructIdArray, constructIdArray, copy, copy, copyVectorToLibraryObjectArray, createDefaultPolicyPropertyBundle, createDefaultPropertyBundle, createInstance, deleteRows, deriveOwnerUniqueName, deriveOwnerUniqueName, deriveUppercasedAttribute, determineClassDomain, determinePolicy, determinePolicy, determineValueDefault, determineValueDomain, dispose, DYNLockRows, equals, executePolicyOperation, extendedPostFree, extendedPreCopy, findPolicyFromPropertyBundleAv, free, free, getAttribute, getAttributeByUpperCaseName, getAuditCertificateName, getAuditDomainContext, getAuditEventFolderContext, getClassData, getClassId, getClassName, getClassObject, getData, getDefinition, getEffectivePolicyActionContexts, getEffectivePolicyListElements, getEventualAttributeByUpperCaseName, getId, getLibraryConnection, getName, getObjectReferenceAttribute, getPropertyBundle, getPropertyValue, getResourceString, getResourceString, getService, getSession, getSessionInterface, getTraceLogger, handleEvent, hashCode, hasNameAttribute, insertReferenceAttributes, insertRow, insertRows, invalidateState, invokeOperation, invokePolicyMethod, isAuditCertificateSecured, isBroadcastCreateEventEnabled, isInstanceOf, issueCascade, isTraced, lockRows, postEvent, postEvent, postFree, postInsert, postUpdate, preFree, preInsert, preUpdate, renderAsReader, renderAsStream, setAttribute, setAttribute, setAttributes, toString, trace, update, updateRows, verifyCanGetContent, verifyCanSetContent, verifyCanSetPolicy, verifyWriteableTransactionInProgress`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface oracle.ifs.common.LibraryObjectInterface
`getAttributeByUpperCaseName, getClassId, getId, getSessionInterface`

Methods inherited from interface oracle.ifs.common.Traceable
`getTraceLogger, isTraced, trace`

Field Detail

### CLASS_NAME

    public static final java.lang.String CLASS_NAME

See Also:
  Constant Field Values
(Unpublished)

Constructor Detail

### S_Relationship

    protected S_Relationship(S_LibrarySession session,
                             S_LibraryObjectData data)
                      throws IfsException

  Construct a S_Relationship object. This is the standard variant.

  Parameters:
    `session` - current LibrarySession
    `data` - Data component
  Throws:
    `IfsException`
  (Unpublished)

### S_Relationship

    protected S_Relationship(S_LibrarySession session,
                             java.lang.Long classId)
                      throws IfsException

  Construct a S_Relationship object. This variant is used for objects taht have not been created in the database yet.

  Parameters:
    `session` - current LibrarySession
  Throws:
    `IfsException`
  (Unpublished)

Method Detail

### getLeftObject

    public S_PublicObject getLeftObject()
                                 throws IfsException

  Description copied from class: `S_Relationship`
  gets the S_PublicObject that is left of this relationship.

  Returns:
    the Left object
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getRightObject

    public S_PublicObject getRightObject()
                                  throws IfsException

  Description copied from class: `S_Relationship`
  gets the S_PublicObject that is right of this relationship.

  Returns:
    the Right object
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### handleCascade

    protected void handleCascade(OperationState opState,
                                 S_LibraryObject source,
                                 int cascadeType,
                                 S_LibraryObjectDefinition sdef,
                                 java.lang.Object customArg)
                          throws IfsException

  Description copied from class: `S_Relationship`
  handle a cascaded operation initiated by (usually) another object. This is overridden by classes to add custom handlers. It is ok if no class handles the cascade (that is implied to mean "no action needed").

  Overrides:
    `handleCascade` in class `S_SystemObject`
  Parameters:
    `opState` - originating operation state
    `source` - object initiating this cascade request (not necessarily the original object)
    `cascadeType` - type of cascade request
    `sdef` - original Definition object
    `customArg` - any custom parameter.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### cascadeFree

    protected void cascadeFree(OperationState opState,
                               S_LibraryObjectDefinition def)
                        throws IfsException

  Description copied from class: `S_Relationship`
  cascade operations to be performed before freeing an object. This is overridden by classes that need to perform operations before successfully freeing the rows for the freed instance.

  Overrides:
    `cascadeFree` in class `S_SystemObject`
  Parameters:
    `opState` - originating operation state
    `def` - original Definition object
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### cascadeFreeToLeftObject

    protected void cascadeFreeToLeftObject(OperationState opState,
                                           S_LibraryObject source)
                                    throws IfsException

  Description copied from class: `S_Relationship`
  cascade to our left object, indicationg that we have freed.

  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### cascadeFreeToRightObject

    protected void cascadeFreeToRightObject(OperationState opState,
                                            S_LibraryObject source)
                                     throws IfsException

  Description copied from class: `S_Relationship`
  cascade to our right object, indicationg that we have freed.

  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### cascadeDeleteToLeftObject

    protected void cascadeDeleteToLeftObject(OperationState opState,
                                             S_LibraryObject source)
                                      throws IfsException

  Description copied from class: `S_Relationship`
  cascade to our left object, indicationg that we have Deleted.

  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### cascadeDeleteToRightObject

    protected void cascadeDeleteToRightObject(OperationState opState,
                                              S_LibraryObject source)
                                       throws IfsException

  Description copied from class: `S_Relationship`
  cascade to our right object, indicationg that we have Deleted.

  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### cascadeUndeleteToLeftObject

    protected void cascadeUndeleteToLeftObject(OperationState opState,
                                               S_LibraryObject source)
                                        throws IfsException

  Description copied from class: `S_Relationship`
  cascade to our left object, indicationg that we have Undeleted.

  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### cascadeUndeleteToRightObject

    protected void cascadeUndeleteToRightObject(OperationState opState,
                                                S_LibraryObject source)
                                         throws IfsException

  Description copied from class: `S_Relationship`
  cascade to our right object, indicationg that we have Undeleted.

  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### extendedPreInsert

    protected void extendedPreInsert(OperationState opState,
                                     S_LibraryObjectDefinition sdef)
                              throws IfsException

  Description copied from class: `S_Relationship`
  Update any system attributes appropriate for creating this object

  Overrides:
    `extendedPreInsert` in class `S_SystemObject`
  Parameters:
    `opState` - current operation state
    `sdef` - current object definition to be updated with system attributes
  Throws:
    `IfsException` - if operation fails.
  (Published)

### deriveDefinition

    protected void deriveDefinition(S_LibraryObjectDefinition def)
                             throws IfsException

  Description copied from class: `S_Relationship`
  Add to the S_LibraryObjectDefinition for this class. This this called by getDefinition() on S_LibraryObject. This must call super.deriveDefinition() before applying any class-specific changes to the S_LibraryObjectDefinition object.

  Overrides:
    `deriveDefinition` in class `S_SystemObject`
  Parameters:
    `def` - the S_LibraryObjectDefinition that contains the definition of the target object.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### vectorToSRelationshipArray

    protected static S_Relationship[] vectorToSRelationshipArray(S_LibrarySession sess,
                                                                 java.util.Vector vector)
                                                          throws IfsException

  Throws:
    `IfsException`
  (Unpublished)

### associatedPreInsert

    protected void associatedPreInsert(OperationState opState,
                                       S_LibraryObjectDefinition def)
                                throws IfsException

  Description copied from class: `S_Relationship`
  an extensibility point for pre insert actions on associated objects. A relationship was created call extendedPreAddRelationship. This can be overridden to update different associated objects.

  Overrides:
    `associatedPreInsert` in class `S_LibraryObject`
  Parameters:
    `opState` - the operation state
    `def` - the LibraryObjectDefinition that contains the settings for the new instance.
  Throws:
    `IfsException` - if any other aspect of the operation fails.
  (Unpublished)

### associatedPostInsert

    protected void associatedPostInsert(OperationState opState,
                                        S_LibraryObjectDefinition def)
                                 throws IfsException

  Description copied from class: `S_Relationship`
  an extensibility point for post insert actions on associated objects. A relationship was created call extendedPostAddRelationship. This can be overridden to update different associated objects.

  Overrides:
    `associatedPostInsert` in class `S_LibraryObject`
  Parameters:
    `opState` - the operation state
    `def` - the LibraryObjectDefinition that contains the settings for the new instance.
  Throws:
    `IfsException` - if any other aspect of the operation fails.
  (Unpublished)

### associatedPostFree

    protected void associatedPostFree(OperationState opState,
                                      S_LibraryObjectDefinition def)
                               throws IfsException

  Description copied from class: `S_Relationship`
  an extensibility point for post free actions on associated objects. A relationship was freed call extendedPostFreeRelationship. This can be overridden to update different associated objects.

  Overrides:
    `associatedPostFree` in class `S_LibraryObject`
  Parameters:
    `opState` - the operation state
    `def` - the LibraryObjectDefinition for this operation
  Throws:
    `IfsException` - if any other aspect of the operation fails.
  (Unpublished)

### extendedPreFree

    protected void extendedPreFree(OperationState opState,
                                   S_LibraryObjectDefinition def)
                            throws IfsException

  Description copied from class: `S_Relationship`
  Processing appropriate for freeing this object Save the left object away for post free processing

  Overrides:
    `extendedPreFree` in class `S_LibraryObject`
  Parameters:
    `opState` - the operation state
    `def` - current object definition to be freed
  Throws:
    `IfsException` - if operation fails.
  (Published)

### extendedPreAddRelationship

    protected void extendedPreAddRelationship(OperationState opState,
                                              S_PublicObject rightpo,
                                              S_LibraryObjectDefinition def)
                                       throws IfsException

  Description copied from class: `S_Relationship`
  an extensibility point before a relationship is created.

  Parameters:
    `opState` - the operation state
    `rightpo` - the item being added to the folder
    `def` - the LibraryObjectDefinition that contains the settings for the new instance.
  Throws:
    `IfsException` - if any other aspect of the operation fails.
  (Published)

### extendedPostAddRelationship

    protected void extendedPostAddRelationship(OperationState opState,
                                               S_PublicObject rightpo,
                                               S_LibraryObjectDefinition def)
                                        throws IfsException

  Description copied from class: `S_Relationship`
  an extensibility point after a relationship is created.

  Parameters:
    `opState` - the operation state
    `rightpo` - the item being added to the folder
    `def` - the LibraryObjectDefinition that contains the settings for the new instance.
  Throws:
    `IfsException` - if any other aspect of the operation fails.
  (Published)

### extendedPreRemoveRelationship

    protected void extendedPreRemoveRelationship(OperationState opState,
                                                 S_PublicObject rightpo,
                                                 S_LibraryObjectDefinition def)
                                          throws IfsException

  Description copied from class: `S_Relationship`
  an extensibility point before a relationship is removed.

  Parameters:
    `opState` - the operation state
    `rightpo` - the item being removed from the folder
  Throws:
    `IfsException` - if any other aspect of the operation fails.
  (Published)

### extendedPostRemoveRelationship

    protected void extendedPostRemoveRelationship(OperationState opState,
                                                  S_PublicObject rightpo,
                                                  S_LibraryObjectDefinition def)
                                           throws IfsException

  Description copied from class: `S_Relationship`
  an extensibility point after a relationship is removed.

  Parameters:
    `opState` - the operation state
    `rightpo` - the item being removed from the folder
  Throws:
    `IfsException` - if any other aspect of the operation fails.
  (Published)

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD